class authconfig (
	$winbind 	=> 'false',
	$smbrealm 	=> 'NIH.GOV',
	$smbworkgroup 	=> 'NIH',
	$smbservers	=> 'nih.gov',
	$smbsecurity	=> 'ads',
	$windbindshell	=> '/bin/bash',
	$krb5realm	=> 'NIH.GOV',
	$krb5kdc	=> 'nih.gov',
	$krb5adminserver => 'nih.gov',
	$ldapserver	=> 'ldap://ldapad.nih.gov',
	$ldapbasedn	=> 'ou=dir,ou=ninds,ou=nih,ou=ad,dc=nih,dc=gov',
){

package { 'samba-winbind':
	ensure	=> present,
	}
package { 'krb5-workstation':
	ensure	=> present,
	}
package { 'samba-wind-krb5-locator':
	ensure	=> present,
	}
package { 'openldap-clients':
	ensure	=> present,
	}
package { 'authconfig':
	ensure => present,
	}
if $winbind{
	service { 'winbind':
		ensure  => running,
    	enable  => true,
	}
	service { 'sssd':
		ensure	=> stopped,
		enable	=> false,
	}
	exec { 'run_authconfig':
		command	=>	'/usr/sbin/authconfig --enablewinbind --enablewins --enablewinbindauth --smbsecurity $smbsecurity --smbworkgroup=$smbworkgroup --smbrealm $smbrealm --smbservers=$smbservers --kbr5realm=$smbrealm --enablewinbindoffline --enableeinbindkrb5 --windbindtemplateshell=$windbindshell --update --enablelocalauthorize --savebackup=/backups'
	}
	exec { 'run_bind':
		command	=> 	'net ads join -Uaabishopja',
		notify  => 	Service['winbind'], 
	}
}
else {
	exec { 'run_sssd_authconfig':
		command	=>	'authconfig --update --enableldap --ldapserver=ldap://ldapad.nih.gov --ldapbasedn="ou=dir,ou=ninds,ou=nih,ou=ad,dc=nih,dc=gov" --enablekrb5 --krb5realm NIH.GOV --krb5kdc nih.gov --krb5adminserver nih.gov --enablesssd --enablesssdauth'
	}
	service { 'winbind':
		ensure  => stopped,
		enable  => false,
	}
	service { 'sssd':
		ensure	=> running,
		enable	=> true,
	}
   }
}


